/**
*******************************************************************
program that ask user to input three particular fields of student
and stores it in form of LinkedList then alllow user to search the
student record by name, ID and display all record that were in
LinkedList in original order
******************************************************************
*/

import java.io.*;
class StuRecord
{
    public String stuName;
    public String stuID;
    public int stuMark;
    public StuRecord(String name, String id, int mark)
    {
        stuName = new String(name);
        stuID = new String(id);
        stuMark = mark;
    }
    public void print() {
        System.out.println( "name: " + stuName +"\t id: " + stuID + "\t mark: " + stuMark);
    }
}
public class RecordLink
{
    private StuRecord record;
    private RecordLink next;
    public RecordLink(StuRecord rec, RecordLink next)
    {
        record = rec;
        this.next = next;
    }
    public RecordLink()
    {

    }

    public StuRecord getRecord()
    {
        return record;
    }

    public RecordLink getNext()
    {
        return next;
    }

    public void instruction() throws Exception
    {
        System.out.println("\n0: To exit the program");
        System.out.println("1: To Search Record by ID");
        System.out.println("2: To display all records in original order");
        System.out.println("3: To Find the Record by Name");
    }

    public void printDetails() {
        System.out.println( "name: " + record.stuName + "\t id: " + record.stuID + "\t mark: " + record.stuMark);
				}

    public void fillList()
    {
        try
            {
                BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
                boolean cont = true;
                char ans;
                while(cont)
                    {
                        System.out.print("\nEnter Name: ");
                        String name = input.readLine();
                        System.out.print("\nEnter ID: ");
                        String id = input.readLine();
                        System.out.print("\nEnter mark: ");
                        int  mark = Integer.parseInt( input.readLine());
                        StuRecord rec = new StuRecord(name, id, mark);

                        insertAfter(rec);


                        System.out.print("\nDo you want to insert another record?: ");
                        String answer = input.readLine();

                        ans = answer.charAt(0);

                        if ( ans=='y' || ans =='Y')
                            {
                                cont = true;
                            }
                        else
                            {
                                cont = false;
                            }
                    }
            }
        catch(Exception e)
            {

                e.printStackTrace();
            }
    }
    public void Delete() throws Exception
    {
								BufferedReader inputID = new BufferedReader(new InputStreamReader(System.in));
								System.out.print("\nEnter ID to Delete the record from list: ");
								String searchID = inputID.readLine();
								RecordLink temp = next;
								RecordLink pre = null;
								RecordLink curr = temp;
								RecordLink tempPtr;
								//check for the Empty List
								if(temp ==null)
												{
																System.out.println("Empty List! No Such a Record");
												}
								//If there is only record
								else if(curr.getRecord().stuID.equals(searchID))
												{
																pre = curr;
																curr = curr.next();
																temp.remove(pre);
																System.out.println(searchID + "Found in the list and deleted it");
																System.out.println("After Deleting, List is: ");
																displayFront();
												}

								else
												{
																pre = temp;
																curr = temp.next;

																while(curr != null && curr.getRecord().stuID != searchID)
																				{
																								pre = curr;
																								curr = curr.next;
																				}

																if(curr !=null)
																				{
																								tempPtr = curr;
																								pre.next = curr.next;
																								temp.remove(tempPtr);
																								displayFront();
																				}
												}
				}


    public void insertBefore(StuRecord rec )
    {
        next = new RecordLink(rec, next);
    }
    public void insertAfter(StuRecord rec)
    {
        if (next == null)
            next = new RecordLink(rec, null);
        else {
            RecordLink temp = next;
            while (temp.next != null )
                temp = temp.next;
            temp.next = new RecordLink(rec, null);
        }
    }

    public void displayFront()
    {
        RecordLink temp = next;
        while(temp != null)
            {

                temp.printDetails();
                temp = temp.next;
            }
    }

    public boolean searchById() throws Exception
    {
        RecordLink temp = next;
        BufferedReader value  = new BufferedReader(new InputStreamReader(System.in));
        System.out.print("\nEnter Student ID: ");
        String Key = value.readLine();
        while(temp != null)
            {
                if(temp.getRecord().stuID.equals(Key))
                    {
                        System.out.println(Key+   " found in the list\n");
                        temp.printDetails();
                        System.out.print("\n");
                        instruction();

                        return true;
                    }
                temp = temp.getNext();
            }
        System.out.println(Key + " not found in the list");
        return false;

    }


    public boolean SearchByName() throws Exception
    {
        RecordLink temp = next;
        BufferedReader value  = new BufferedReader(new InputStreamReader(System.in));
        System.out.print("\nEnter Student Name: ");
        String searchName = value.readLine();
        while(temp != null)
            {
                if(temp.getRecord().stuName.equals(searchName))
                    {
                        System.out.println(searchName+   " found in the list\n");
                        temp.printDetails();
                        System.out.print("\n\n");
                        instruction();


                        return true;
                    }
                temp = temp.getNext();
            }
        System.out.println(searchName + " not found in the list");
        return false;
    }

    public static void main(String [] args) throws Exception
    {
        BufferedReader num = new BufferedReader(new InputStreamReader(System.in));
        int choice = 3;
        RecordLink list = new RecordLink();

        list.fillList();
        list.instruction();
        while ( choice != 0)  {
            System.out.print("\nEnter Your Choice: ");
            String c  = num.readLine();
            choice  = Integer.parseInt(c);
            if(choice ==1)
																{
																				list.searchById();
																}
												else if(choice ==2)
																{
																				list.displayFront();
																}
            else if(choice ==3)
																{
																				list.SearchByName();

																}

            else if(choice ==5)
																{
																				list.Delete();
																}

            else if (choice == 0)
                break;
            else
                System.out.println("invalid choice");
        }
    }
}

